#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ncurses.h>

#include "include/main.h"
#include "include/snake.h"
#include "../config.h"

void die(char *fmt, ...) {
    va_list args;
    va_start(args, fmt);

    fprintf(stderr, "fatal: ");
    vfprintf(stderr, fmt, args);
    fprintf(stderr, "\n");

    va_end(args);
    exit(1);
}

void free_s(void *p) {
    free(p);
    p = NULL;
}

int main(void) {
    int c, dirn;
    Snake *s;

    // init ncurses
    initscr();
    keypad(stdscr, true);
    noecho();
    cbreak();
    nodelay(stdscr, true);
    curs_set(0);

    s = new_snake(starting_len, getmaxx(stdscr) / 2, getmaxy(stdscr) / 2);
    dirn = UP;

    while ((c = getch())) {
        switch (c) {
            case    up_key: dirn = UP;    break;
            case  down_key: dirn = DOWN;  break;
            case right_key: dirn = RIGHT; break;
            case  left_key: dirn = LEFT;  break;
            case  quit_key: goto quit;
        }
        snake_forward(s, dirn);
        clear();
        refresh();
        snake_print(s);
        refresh();
        napms(screen_speed);
    } 

quit:
    delete_snake(s);
    endwin();
}
